[@functional-abstraction/functools](https://functional-abstraction.github.io/functools)
==

Function tools for JavaScript.
See [docs](https://functional-abstraction.github.io/functoolsindex.html).
Parent is [js-library](https://github.com/make-github-pseudonymous-again/js-library).

```js
let j = ( a , b , c , x ) => a * x**2 + b * x + c ;
let p = partial( j , [ 5 , 4 , -1 ] ) ;
p( -1 ) ; // 5 - 4 - 1 = 0
```

[![License](https://img.shields.io/github/license/functional-abstraction/functools.svg)](https://raw.githubusercontent.com/functional-abstraction/functools/main/LICENSE)
[![Version](https://img.shields.io/npm/v/@functional-abstraction/functools.svg)](https://www.npmjs.org/package/@functional-abstraction/functools)
[![Tests](https://img.shields.io/github/workflow/status/functional-abstraction/functools/ci:test?event=push&label=tests)](https://github.com/functional-abstraction/functools/actions/workflows/ci:test.yml?query=branch:main)
[![Dependencies](https://img.shields.io/david/functional-abstraction/functools.svg)](https://david-dm.org/functional-abstraction/functools)
[![Dev dependencies](https://img.shields.io/david/dev/functional-abstraction/functools.svg)](https://david-dm.org/functional-abstraction/functools?type=dev)
[![GitHub issues](https://img.shields.io/github/issues/functional-abstraction/functools.svg)](https://github.com/functional-abstraction/functools/issues)
[![Downloads](https://img.shields.io/npm/dm/@functional-abstraction/functools.svg)](https://www.npmjs.org/package/@functional-abstraction/functools)

[![Code issues](https://img.shields.io/codeclimate/issues/functional-abstraction/functools.svg)](https://codeclimate.com/github/functional-abstraction/functools/issues)
[![Code maintainability](https://img.shields.io/codeclimate/maintainability/functional-abstraction/functools.svg)](https://codeclimate.com/github/functional-abstraction/functools/trends/churn)
[![Code coverage (cov)](https://img.shields.io/codecov/c/gh/functional-abstraction/functools/main.svg)](https://codecov.io/gh/functional-abstraction/functools)
[![Code technical debt](https://img.shields.io/codeclimate/tech-debt/functional-abstraction/functools.svg)](https://codeclimate.com/github/functional-abstraction/functools/trends/technical_debt)
[![Documentation](https://functional-abstraction.github.io/functools/badge.svg)](https://functional-abstraction.github.io/functools/source.html)
[![Package size](https://img.shields.io/bundlephobia/minzip/@functional-abstraction/functools)](https://bundlephobia.com/result?p=@functional-abstraction/functools)

## Reference

  - https://docs.python.org/3/library/functions.html
  - https://docs.python.org/3/library/functools.html
  - https://github.com/lodash/lodash
